fix codesonar finding: add CLOSE(fd)
[oweals/gnunet.git] / src / gns / test_gns_quickupdate.sh
1 #!/bin/bash
2 trap "gnunet-arm -e -c test_gns_lookup.conf" SIGINT
3
4 LOCATION=$(which gnunet-config)
5 if [ -z $LOCATION ]
6 then
7   LOCATION="gnunet-config"
8 fi
9 $LOCATION --version 1> /dev/null
10 if test $? != 0
11 then
12         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
13         exit 77
14 fi
15
16 MY_EGO="myego"
17 OTHER_EGO="delegatedego"
18
19
20 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
21 which timeout &> /dev/null && DO_TIMEOUT="timeout 5"
22 TEST_IP="127.0.0.1"
23 gnunet-arm -s -c test_gns_lookup.conf
24 gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
25 gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
26 DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
27 gnunet-arm -i gns -c test_gns_lookup.conf
28 gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
29 # Give GNS/namestore time to fully start and finish initial iteration
30 sleep 2
31 # Performing namestore update
32 gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
33 # Give GNS chance to observe store event via monitor
34 sleep 1
35 gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP  -e never -c test_gns_lookup.conf
36 # give GNS chance to process monitor event
37 sleep 1
38 # stop everything and restart to check that DHT PUT did happen
39 gnunet-arm -k gns -c test_gns_lookup.conf
40 gnunet-arm -k namestore -c test_gns_lookup.conf
41 gnunet-arm -k namecache -c test_gns_lookup.conf
42 gnunet-arm -k zonemaster -c test_gns_lookup.conf
43 # Purge nameacache, as we might otherwise fetch from there
44 # FIXME: testcase started failing after the line below was fixed by adding '-f',
45 # might have never worked (!)
46 rm -r `gnunet-config -f -c test_gns_lookup.conf -s namecache-sqlite -o FILENAME`
47 gnunet-arm -i namestore -c test_gns_lookup.conf
48 gnunet-arm -i namecache -c test_gns_lookup.conf
49 gnunet-arm -i zonemaster -c test_gns_lookup.conf
50 gnunet-arm -i gns -c test_gns_lookup.conf
51 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
52 gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_lookup.conf
53 gnunet-identity -D $MY_EGO -c test_gns_lookup.conf
54 gnunet-identity -D $OTHER_EGO -c test_gns_lookup.conf
55 gnunet-arm -e -c test_gns_lookup.conf
56 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
57
58 if [ "$RES_IP" == "$TEST_IP" ]
59 then
60   exit 0
61 else
62   echo "Failed to properly resolve IP, expected $TEST_IP, got $RES_IP."
63   exit 1
64 fi